Codeforces Round #424 (Div. 2) D. Office Keys(dp)

D. Office Keys
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

There are n people and k keys on a straight line. Every person wants to get to the office which is located on the line as well. To do that, he needs to reach some point with a key, take the key and then go to the office. Once a key is taken by somebody, it couldn't be taken by anybody else.

You are to determine the minimum time needed for all n people to get to the office with keys. Assume that people move a unit distance per 1 second. If two people reach a key at the same time, only one of them can take the key. A person can pass through a point with a key without taking it.

Input

The first line contains three integers nk and p (1 ≤ n ≤ 1 000n ≤ k ≤ 2 0001 ≤ p ≤ 109) — the number of people, the number of keys and the office location.

The second line contains n distinct integers a1, a2, ..., an (1 ≤ ai ≤ 109) — positions in which people are located initially. The positions are given in arbitrary order.

The third line contains k distinct integers b1, b2, ..., bk (1 ≤ bj ≤ 109) — positions of the keys. The positions are given in arbitrary order.

Note that there can't be more than one person or more than one key in the same point. A person and a key can be located in the same point.

Output

Print the minimum time (in seconds) needed for all n to reach the office with keys.

Examples
input
2 4 50
20 100
60 10 40 80
output
50
input
1 2 10
11
15 7
output
7
Note

In the first example the person located at point 20 should take the key located at point 40 and go with it to the office located at point 50. He spends 30 seconds. The person located at point 100 can take the key located at point 80 and go to the office with it. He spends 50seconds. Thus, after 50 seconds everybody is in office with keys.

题意:有n个人k个钥匙,给出目标地点p,和每个人和钥匙的位置,每个人需要拿到一把钥匙才能够通过目标地点,每移动一步需要1s,问所有人都通过的最短时间是多少。

分析:那么因为最大为2000,所以可以用n^2的方法,那么将每个人的位置和钥匙的位置排序后,令i为前i个人,j为前j把钥匙  dp[i][j]为前i个人和前j把钥匙匹配后得到的最优时间。

那么  有两种情况

1,当 i==j时钥匙和人刚好匹配 那么需要的时间是 最小时间里的最大时间。

dp[i][j]=max(dp[i-1][j-1],第i个人距第j把钥匙的距离+第j把钥匙到终点的距离)

2,当i

dp[i][j]=min(dp[i][j-1],max(dp[i-1][j-1],第i个人距第j把钥匙的距离+第j把钥匙到终点的距离))


AC代码;
#include
#include
#include
#include
#define inf 1<<30
using namespace std;
int a[2200],b[2200];
int dp[2200][2200];
int main()
{
	int n,m,p;
	memset(dp,0,sizeof(dp));
	scanf("%d%d%d",&n,&m,&p);
	for(int i=0;i



你可能感兴趣的:(codeforces,基础dp)